
#pragma BEGINDUMP

#include "SET_COMPILE_HMG_UNICODE.ch"
#include "HMG_UNICODE.h"

#include <shlobj.h>
#include <windows.h>
#include <commctrl.h>
#include <tchar.h>
#include "hbapi.h"

HB_FUNC ( TREEVIEW_HITTEST )
{
   HWND        hWndTV     = (HWND) HMG_parnl (1);
   POINT pt ;
   TVHITTESTINFO hti;

   pt.y = hb_parni(2) ;
   pt.x = hb_parni(3) ;

   hti.pt = pt;
     //hti.flags = TVHT_ONITEM | TVHT_ONITEMBUTTON ;
     //hti.flags = TVHT_ONITEMLABEL ;
     HTREEITEM hItem = TreeView_HitTest(hWndTV, &hti) ;

     if(hti.flags & TVHT_ONITEM)
     {
      HMG_retnl ((LONG_PTR) hItem ) ;
   }
   else
   {
      HMG_retnl ((LONG_PTR) 0 ) ;
   }


   //HMG_retnl ((LONG_PTR) hItem ) ;

}

HB_FUNC (TREEVIEW_SELECTDROPTARGET)
{
   HWND      hWndTV     = (HWND) HMG_parnl (1);
   HTREEITEM ItemHandle = (HTREEITEM) HMG_parnl (2);
   TreeView_SelectDropTarget (hWndTV, ItemHandle);
}

HB_FUNC (TREEVIEW_SELECT)
{
   HWND      hWndTV     = (HWND) HMG_parnl (1);
   HTREEITEM ItemHandle = (HTREEITEM) HMG_parnl (2);
   UINT code = (UINT) HMG_parnl (3) ;
   TreeView_Select (hWndTV, ItemHandle, code);
}


HB_FUNC ( TREEVIEW_GETITEMRECT )
{
   RECT Rect;
   HWND hWnd     = (HWND) HMG_parnl (1);
   HTREEITEM ItemHandle = (HTREEITEM) HMG_parnl (2);
   BOOL  code = (BOOL) TRUE;
   TreeView_GetItemRect ( hWnd, ItemHandle, &Rect, code ) ;
   hb_reta( 4 );
   hb_storvni( Rect.top  , -1, 1 );
   hb_storvni( Rect.left  , -1, 2 );
   hb_storvni( Rect.right - Rect.left , -1, 3 );
   hb_storvni( Rect.bottom - Rect.top  , -1, 4 );
}

#define MAX_ITEM_TEXT   1024

HB_FUNC (INSTREEITEM)
{

   HWND hWndTV = (HWND) HMG_parnl (1);

   HTREEITEM PrevItemHandle = (HTREEITEM) HMG_parnl (2);
   HTREEITEM ParentItemHandle = TreeView_GetParent ( hWndTV , PrevItemHandle );
   HTREEITEM ItemHandle ;
     TCHAR     ItemText [ MAX_ITEM_TEXT ] ;
   TV_ITEM tvi;
   TV_INSERTSTRUCT is ;

   lstrcpy ( ItemText , HMG_parc(3) ) ;

   LONG nID        = (LONG) hb_parnl(6);
   BOOL IsNodeFlag = (BOOL) hb_parl (7);

   tvi.mask       = TVIF_TEXT | TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_PARAM ;
   tvi.pszText    = ItemText;
   tvi.cchTextMax = sizeof (ItemText) / sizeof (TCHAR);
   tvi.iImage        = hb_parni(4) ;
   tvi.iSelectedImage   = hb_parni(5) ;
   tvi.lParam     = nID;

   is.item   = tvi;

   //if ( PrevItemHandle == 0 )
   //{
      is.hInsertAfter = PrevItemHandle;
      is.hParent      = ParentItemHandle;
   //}
   //else
   //{
   // is.hInsertAfter = TVI_LAST;
   // is.hParent      = PrevItemHandle;
   //}

   ItemHandle = TreeView_InsertItem(hWndTV, &is);

     AddTreeItemLPARAM (hWndTV, ItemHandle, nID, IsNodeFlag);

   HMG_retnl ((LONG_PTR) ItemHandle ) ;

}

// INSLISTVIEWITEMS ( hWnd, aItem, iImage, [nRow] )
HB_FUNC ( INSLISTVIEWITEMS )
{
   HWND hWnd;
   LV_ITEM LI; 
   int nColumnCount, nCol, nRow;

   hWnd = (HWND) HMG_parnl (1);
   nColumnCount = hb_parinfa (2, 0);
   nRow = hb_parni (4); 

   LI.mask       = LVIF_TEXT | LVIF_IMAGE;
   LI.state      = 0;
   LI.stateMask  = 0;
   LI.iImage     = hb_parni (3);
   LI.iSubItem   = 0;
   LI.iItem      = nRow;
   LI.pszText    = (TCHAR*) HMG_parvc (2, 1);

   ListView_InsertItem (hWnd, &LI);

   for (nCol = 1; nCol < nColumnCount; nCol++)
       ListView_SetItemText (hWnd, nRow, nCol, (TCHAR*) HMG_parvc (2, nCol+1));

}



#pragma ENDDUMP

*
